﻿<?

class Payment
{
  var $shop; // object
  var $params; // array
  
  function Payment(&$shop) // constructor
  {
    if (!$shop->P2P_MerchantId)
    {
      printf (NETCAT_MODULE_NETSHOP_PAYMENT_NO_SETTINGS, "Pay2Pay");
      return false;
    }

    $this->shop = &$shop;
    // load order

    if (!$shop->OrderID && isset($_REQUEST["xml"]))
    {
      $this->shop->LoadOrder($this->GetOrderId());
    }
  }
  function GetOrderId()
  {
    $xml = base64_decode(str_replace(' ', '+', $_REQUEST['xml']));
    $vars = simplexml_load_string($xml);
    return $vars->order_id;
  }
  // создание формы на формирование счета
  function create_bill()
  {
    global $SUB_FOLDER, $HTTP_ROOT_PATH, $DOMAIN_NAME;

    $shop = &$this->shop;
    $currency = ($shop->Currencies[$shop->DefaultCurrencyID] == 'RUR') ? 'RUB' : $shop->Currencies[$shop->DefaultCurrencyID];
    $amount = number_format($shop->CartSum(), 2, '.', '');
    $desc = "Оплата заказа №$shop->OrderID";
      
    $xml = "<?xml version=\"1.0\" encoding=\"UTF-8\"?>
            <request>
              <version>1.2</version>
              <merchant_id>$shop->P2P_MerchantId</merchant_id>
              <language>ru</language>
              <order_id>$shop->OrderID</order_id>
              <amount>$amount</amount>
              <currency>$currency</currency>
              <description>$desc</description>";
    if ($shop->P2P_TestMode == '1')
      $xml .= "<test_mode>1</test_mode>";
    $xml .= "</request>"; 
    $sign = md5($shop->P2P_SecretKey.$xml.$shop->P2P_SecretKey);
      
    print '<form action="https://merchant.pay2pay.com/?page=init" method="post">';
    print '<input type="hidden" name="xml" value="'.base64_encode($xml).'">';
    print '<input type="hidden" name="sign" value="'.base64_encode($sign).'">';
    print "<input type=submit value='".NETCAT_MODULE_NETSHOP_PAYMENT_SUBMIT."'></form>";
  }

  function success() {
    $xml_post = base64_decode(str_replace(' ', '+', $_REQUEST['xml']));
    $sign_post = base64_decode(str_replace(' ', '+', $_REQUEST['sign']));
    
    $vars = simplexml_load_string($xml_post);
    
    $ar_req['status']      = $vars->status;
    $ar_req['order_id']    = $vars->order_id;
    $ar_req['amount']      = $vars->amount;
    
    $shop = &$this->shop;
      
    $sign = md5($shop->P2P_HiddenKey.$xml_post.$shop->P2P_HiddenKey);

    $err = '';
    
    if ($sign_post == $sign)
    {
      $shop->LoadOrder($vars->order_id);
      
      if ($vars->amount >= $shop->CartSum())
      {
        $currency = ($shop->Currencies[$shop->DefaultCurrencyID] == 'RUR') ? 'RUB' : $shop->Currencies[$shop->DefaultCurrencyID];
        if ($vars->currency == $currency)
        {
          if ($vars->status == 'success')
          {
            q("UPDATE Message{$shop->order_table}
               SET Status='3'
               WHERE Message_ID = {$shop->OrderID}");
          }
          /*
          else
          {
            q("UPDATE Message{$shop->order_table}
               SET Status='2'
               WHERE Message_ID = {$shop->OrderID}");
          }
          */
        }
        else
          $err = "Currency check failed";
      }
      else 
        $err = "Amount check failed";
    }
    else
      $err = "Security check failed";
    
    if ($err != '')
      die("<?xml version=\"1.0\" encoding=\"UTF-8\"?><response><status>no</status><err_msg>$err</err_msg></response>");
    else
      die("<?xml version=\"1.0\" encoding=\"UTF-8\"?><response><status>yes</status><err_msg></err_msg></response>");
  }

  // платеж отклонен
  function failed()
  {
  }
}
?>